
#include <Pilot.h>
#include "pocketth.h"
#include "hackuidef.h"
#include "thai.h"

void myWinDrawChars (CharPtr chars, Word len, SWord x, SWord y)
{
	DWord			value;
    void              (*oldTrap)(CharPtr, Word, SWord, SWord);	
	Word			i, charsCount;
	SWord			adjx, chwd, chhg, thx, newx;
	WinHandle		win, tmp;
	RectangleType	rect;
	Word			error;
	unsigned char uChar;
	
	chhg = FntCharHeight();
	win = WinGetDrawWindow();
	rect.topLeft.x = 0;
	rect.topLeft.y = 0;
	rect.extent.x = 10;
	rect.extent.y = chhg-1;
	tmp = WinCreateOffscreenWindow(11, chhg, genericFormat, &error);
	
	//	Get the old trap address from HackMaster.
	FtrGet (MYCRID, trapIDWinDrawChars, &value);
    oldTrap = (void (*)(CharPtr, Word, SWord, SWord)) value;
	
	//oldTrap(chars, len, x, y);
	adjx = 0;
	thx = 0;
	charsCount = 0;
	newx = x;
	
	for (i = 0; i < len; i++)
	{
		chwd = FntCharWidth(chars[i]);

		uChar = (unsigned char) chars[i];
		switch (uChar) {
		case SaraIe:
		case SaraE:
		case SaraUe:
		case SaraUee:
		case SaraU:
		case SaraUU:
		case ThaiDot:
		case MaiTaiKuu:
		case MaiEk:
			if (charsCount > 0) {
				oldTrap(chars+i-charsCount, charsCount, newx, y);
				newx = x + adjx;
				charsCount = 0;
			}
			if (tmp) {
				WinSetDrawWindow(tmp);
				WinEraseWindow();
				oldTrap(chars+i, 1, 0, 0);
				WinSetDrawWindow(win);
				if (i == 0) {
					thx = x - 1;
				} else {
					thx = x + adjx - chwd - 1;
				}
				WinCopyRectangle(tmp, win, &rect, thx, y, scrOR);
			}
			break;
		case HunAkad:
		case MaiToe:
		case MaiTri:
		case MaiJattawa:
		case Karan:
		case ThaiSpecial1:
		case ThaiSpecial2:
			if (charsCount > 0) {
				oldTrap(chars+i-charsCount, charsCount, newx, y);
				newx = x + adjx;
				charsCount = 0;
			}
			if (tmp) {
				WinSetDrawWindow(tmp);
				WinEraseWindow();
				oldTrap(chars+i, 1, 0, 0);
				WinSetDrawWindow(win);
				if (i == 0) {
					thx = x;
				} else {
					thx = x + adjx - chwd;
				}
				WinCopyRectangle(tmp, win, &rect, thx, y, scrOR);
			}
			break;
		/* case SaraUm:
			if (charsCount > 0) {
				oldTrap(chars+i-charsCount, charsCount, newx, y);
				newx = x + adjx;
				charsCount = 0;
			}
			chwd = FntCharWidth(ThaiSpecial1);
			if (tmp) {
				WinSetDrawWindow(tmp);
				WinEraseWindow();
				oldTrap("", 1, 0, 0);
				WinSetDrawWindow(win);
				if (i == 0) {
					thx = x;
				} else {
					thx = x + adjx - chwd;
				}
				WinCopyRectangle(tmp, win, &rect, thx, y, scrOR);
			}
			oldTrap("", 1, newx, y);
			chwd = FntCharWidth(SaraR);
			adjx += chwd;
			newx = x + adjx;
			break; */
		default:
			charsCount++;
			adjx += chwd;
		}
	}
	if (charsCount > 0) {
		oldTrap(chars+i-charsCount, charsCount, newx, y);
		newx = x + adjx;
		charsCount = 0;
	}
	
	if (tmp) {
		WinDeleteWindow(tmp, true);
	}
	
	//	Done!
}
