
#include <Pilot.h>
#include "pocketth.h"
#include "hackuidef.h"
#include "thai.h"

SWord myFntCharWidth (Char ch)
{
	DWord			value;
    SWord         (*oldTrap)(Char);	
	SWord			newCharWidth;
	unsigned char uChar;
	
	//	Get the old trap address from HackMaster.
	FtrGet (MYCRID, trapIDFntCharWidth, &value);
    oldTrap = (SWord (*)(Char)) value;
	
	uChar = (unsigned char) ch;
	switch (uChar) {
	case HunAkad:
	case SaraIe:
	case SaraE:
	case SaraUe:
	case SaraUee:
	case SaraU:
	case SaraUU:
	case ThaiDot:
	case MaiTaiKuu:
	case MaiEk:
	case MaiToe:
	case MaiTri:
	case MaiJattawa:
	case Karan:
	case ThaiSpecial1:
	case ThaiSpecial2:
		newCharWidth = 0;
		break;
	default:
		//	Call the old trap.
		newCharWidth = oldTrap(ch);
	}

	return newCharWidth;
	//	Done!
}